#!/usr/local/bin/perl

# --------------------------------------------------------
#
# createadmin.cgi:
#      cgi for creating administrator for PositLog
#  (tested under perl 5.8.4)
#
# Copyright (c) 2006 Hidekazu Kubota (Taro Sosui) All right reserved
#  <taro@summer.nifty.jp> 
#   http://storybook.jp/
#
# --------------------------------------------------------

# --------------------------------------------------------
# This file is part of PositLog.
#
# PositLog is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# PositLog is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
# --------------------------------------------------------


use strict;
use CGI qw/-debug :standard/;
use Storable qw(lock_nstore);   # is default library (upper perl 5.8)
use PositLogConfig;

my $CGI = new CGI;
my $user = $CGI->param("loginid");
my $password = $CGI->param("loginpass");
my $command = $CGI->param("command");

print $CGI->header(-charset => 'utf-8'); # HTTP header

my $HEADER = "<!DOCTYPE html PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN'\n
   'http://www.w3.org/TR/html4/loose.dtd'>\n
<html lang='ja-JP'>\n
	<head>\n
		<meta http-equiv='Content-Type' content='text/html;charset=UTF-8'>\n
		<meta http-equiv='Content-Style-Type' content='text/css'>\n
		<link rel='stylesheet' href='" . $PositLogConfig::systempath . "logincheck.css' type='text/css'>\n
                <meta http-equiv='Content-Script-Type' content='text/javascript'>
		<title>PositLog Administration</title>\n"
	. "</head>\n";

my $BODY = "<body>\n";

if (! -f $PositLogConfig::adminpath . "key.cgi")
{
	if($user ne "" && $password ne "" && $command eq "create")
	{
		if($user =~ /[^a-zA-Z0-9\_\-\@]/)
		{
			print "<div style='text-align: center'>Administrator's name includes invalid characters.<br>\n";
			print "<a href='./createadmin.cgi'>back</a></div>\n";
			exit(0);
		}
		if($password =~ /[^a-zA-Z0-9\_\!\#\%\&\(\)\*\+\-\/\.\:\;\<\=\>\'\"\\\?\@\[\]\^\`\{\|\}]/)
		{
			print "<div style='text-align: center'>The password includes invalid characters.<br>\n";
			print "<a href='./createadmin.cgi'>back</a></div>\n";
			exit(0);
		}
		if(length($password) > 8)
		{
			print "<div style='text-align: center'>The password is too long.<br>\n";
			print "<a href='./createadmin.cgi'>back</a></div>\n";
			exit(0);

		}

		my %admin = {};
		my $salt = "lc";
		$admin{$user}{"password"} = crypt($password, $salt);
		if(!eval{Storable::lock_nstore \%admin, $PositLogConfig::adminpath . "key.cgi"})
		{
			print "Cannot create administration user.\n";
			print "Please check file permission.\n";
			exit(0);
		}
		$BODY .= "<div id='logintop'>\n
  <div id='login'>\n
  <p style='color:red; font-size:18px'>\n
  Succeed!
  </p></div></div>\n";

	}
	else
	{
		$BODY .= "<div id='logintop'>\n
  <div id='login'>\n
  <h1>Create administrator for PositLog</h1>\n";

		if($user eq "" && $command eq "create")
		{
			$BODY .= "<p style='color:red; font-size:12px;'>Error!&nbsp;&nbsp;&nbsp;Please enter the name of administrator."
		}
		if($password eq "" && $command eq "create")
		{
			$BODY .= "<p style='color:red; font-size:12px;'>Error!&nbsp;&nbsp;&nbsp;Please enter the password for administrator."
		}

		$BODY .= "<form id='loginform' action='createadmin.cgi' method='post'>\n
    <p class='availablechar'>\n
      管理者（admin）の id を入力してください．<br>\n
      利用可能な文字は次のものです：0-9a-zA-Z @ _ -\n
    </p>\n
    <p>\n
      <input type='text' name='loginid' id='loginid' value='' size='20' tabindex='1'>\n
    </p>\n
    <p class='availablechar'>\n
      管理者（admin）のパスワードを入力してください.<br>\n
      最大文字数は8文字です．<br>\n
      また，利用可能な文字は次のものです：0-9a-zA-Z ! # $ \% &amp; ( ) * + - . / \\ \' \" : ; &lt; = &gt; ? @ [ ] ^ ~ _ ` { | }\n
    </p>\n
    <p>\n
      <input type='password' name='loginpass' id='loginpass' value='' maxlength='8' size='10' tabindex='2'>\n
      <input type='hidden' name='command' id='command' value='create'>\n
    </p>\n
    <p><input type='submit' id='submitbtn' value='Create' tabindex='3'></p>\n
  </form>\n
  </div>\n
  </div>\n";
	}
}
else
{	
	$BODY .= "<p>Administrator already exists.<br>Please delete key.cgi under your adminpath if you want to change administrator's name and password.</p>"
}

$BODY .= "</body>\n";

my $FOOTER = "</html>";

print $HEADER . $BODY . $FOOTER;



